import uvm_pkg::*;
`include "uvm_macros.svh"
import router_pkg::*;
class router_env extends uvm_env;
	`uvm_component_utils(router_env)

	router_agent router_agnt;
	router_scoreboard router_sb;

	function new(string name, uvm_component parent);
		super.new(name, parent);
	endfunction: new

	function void build_phase(uvm_phase phase);
		super.build_phase(phase);
		router_agnt	= router_agent::type_id::create(.name("router_agnt"), .parent(this));
		router_sb	= router_scoreboard::type_id::create(.name("router_sb"), .parent(this));
	endfunction: build_phase

	function void connect_phase(uvm_phase phase);
		super.connect_phase(phase);
		router_agnt.agent_ap_minput.connect(router_sb.sb_export_minput);
		router_agnt.agent_ap_moutput.connect(router_sb.sb_export_moutput);
	endfunction: connect_phase
endclass: router_env