import uvm_pkg::*;
`include "uvm_macros.svh"
import router_pkg::*;
class router_s_agent extends uvm_agent;
	`uvm_component_utils(router_s_agent)

	uvm_analysis_port#(router_s_transaction) agent_ap_minput;
	uvm_analysis_port#(router_s_transaction) agent_ap_moutput;

	router_s_sequencer	router_seqr;
	router_s_driver		router_drvr;
	router_s_monitor_input	router_mon_input;
	router_s_monitor_output	router_mon_output;

	function new(string name, uvm_component parent);
		super.new(name, parent);
	endfunction: new

	function void build_phase(uvm_phase phase);
		super.build_phase(phase);

		agent_ap_minput	 = new(.name("agent_ap_minput"), .parent(this));
		agent_ap_moutput = new(.name("agent_ap_moutput"), .parent(this));

		router_seqr	 = router_s_sequencer::type_id::create(.name("router_seqr"), .parent(this));
		router_drvr	 = router_s_driver::type_id::create(.name("router_drvr"), .parent(this));
		router_mon_input = router_s_monitor_input::type_id::create(.name("router_mon_input"), .parent(this));
		router_mon_output = router_s_monitor_output::type_id::create(.name("router_mon_output"), .parent(this));
	endfunction: build_phase

	function void connect_phase(uvm_phase phase);
		super.connect_phase(phase);

		router_drvr.seq_item_port.connect(router_seqr.seq_item_export);
		router_mon_input.mon_ap_minput.connect(agent_ap_minput);
		router_mon_output.mon_ap_moutput.connect(agent_ap_moutput);
	endfunction: connect_phase
endclass: router_s_agent
