import uvm_pkg::*;
`include "uvm_macros.svh"
import router_pkg::*;
`include "common_defs.v"

//parameter LINKWIDTH = `IC_WIDTH;  //90
parameter TILE_X = 4'd1; // x-coordinate of the tile
parameter TILE_Y = 4'd1; // y-coordinate of the tile

class router_s_transaction extends uvm_sequence_item;
	rand int nr_inport;   
	rand logic [`IC_WIDTH-1:0] indata; 
	logic [`IC_WIDTH-1:0] outdata;
	logic [4:0] out_dir;
	
	//constraints
	constraint nr_inport_c {
		nr_inport inside {0, 1, 2, 3, 4};
	}

	constraint indata_c {
		indata[`DEST_X_END:`DEST_X_BEGIN] inside {4'd0, 4'd1, 4'd2};
		indata[`DEST_Y_END:`DEST_Y_BEGIN] inside {4'd0, 4'd1, 4'd2};	
	}	

	function new(string name = "");
		super.new(name);
	endfunction: new

	`uvm_object_utils(router_s_transaction)
	
endclass: router_s_transaction

class router_s_sequence extends uvm_sequence#(router_s_transaction);
	`uvm_object_utils(router_s_sequence)

	function new(string name = "");
		super.new(name);
	endfunction: new

	task body();
		router_s_transaction router_tx;
		
		repeat(5) begin
		router_tx = router_s_transaction::type_id::create(.name("router_tx"), .contxt(get_full_name()));

		start_item(router_tx);
		assert(router_tx.randomize());
		finish_item(router_tx);
		end
	endtask: body
endclass: router_s_sequence

typedef uvm_sequencer#(router_s_transaction) router_s_sequencer;
