`include "router_pkg.sv"
`include "router.v"
`include "router_if.sv"

import uvm_pkg::*;
`include "uvm_macros.svh"
import router_pkg::*;

module router_tb_top;
	import uvm_pkg::*;

	//Interface declaration
	router_if vif();

	//Connects the Interface to the DUT
	router dut (	.clk (vif.sig_clk),
            		.rst (vif.sig_rst),
		        .req_in (vif.sig_req_in),
             		.data_in (vif.sig_data_in),
             		.rdy_in (vif.sig_rdy_in),
			.req_out (vif.sig_req_out),
			.data_out (vif.sig_data_out),
             		.rdy_out (vif.sig_rdy_out)
        );

   	initial begin
		//Registers the Interface in the configuration block so that other
		//blocks can use it
		uvm_resource_db#(virtual router_if)::set
			(.scope("ifs"), .name("router_if"), .val(vif));

		//Executes the test
		run_test();
	end

	//Variable initialization
	initial begin
		vif.sig_clk <= 1'b1;
	end

	//Clock generation
	always
		#5 vif.sig_clk = ~vif.sig_clk;
endmodule