import uvm_pkg::*;
`include "uvm_macros.svh"
import sha1_pkg::*;
class sha1_env extends uvm_env;
	`uvm_component_utils(sha1_env)

	sha1_agent sha1_agnt;
	sha1_scoreboard sha1_sb;

	function new(string name, uvm_component parent);
		super.new(name, parent);
	endfunction: new

	function void build_phase(uvm_phase phase);
		super.build_phase(phase);
		sha1_agnt	= sha1_agent::type_id::create(.name("sha1_agnt"), .parent(this));
		sha1_sb		= sha1_scoreboard::type_id::create(.name("sha1_sb"), .parent(this));
	endfunction: build_phase

	function void connect_phase(uvm_phase phase);
		super.connect_phase(phase);
		sha1_agnt.agent_ap_minput.connect(sha1_sb.sb_export_minput);
		sha1_agnt.agent_ap_moutput.connect(sha1_sb.sb_export_moutput);
	endfunction: connect_phase
endclass: sha1_env