`include "sha1_pkg.sv"
`include "Sha1.v"
`include "sha1_if.sv"

import uvm_pkg::*;
`include "uvm_macros.svh"
import sha1_pkg::*;

module sha1_tb_top;
	import uvm_pkg::*;

	//Interface declaration
	sha1_if vif();

	//Connects the Interface to the DUT
	Sha1 dut (	.clk (vif.sig_clk),
            		.reset (vif.sig_rst),
		        .io_req_in (vif.sig_req_in),
             		.io_rdy_in (vif.sig_rdy_in),
             		.io_in_addr (vif.sig_in_addr),
             		.io_in_burst (vif.sig_in_burst),
             		.io_in_reply (vif.sig_in_reply),
	             	.io_in_write (vif.sig_in_write),
	             	.io_in_mask (vif.sig_in_mask),
             		.io_in_exclusive (vif.sig_in_exclusive),
             		.io_in_data (vif.sig_in_data),
             		.io_in_sender (vif.sig_in_sender),
             		.io_req_out (vif.sig_req_out),
             		.io_rdy_out (vif.sig_rdy_out),
             		.io_out_addr (vif.sig_out_addr),
             		.io_out_burst (vif.sig_out_burst),
             		.io_out_reply (vif.sig_out_reply),
             		.io_out_write (vif.sig_out_write),
            		.io_out_mask (vif.sig_out_mask),
             		.io_out_exclusive (vif.sig_out_exclusive),
             		.io_out_data (vif.sig_out_data),
             		.io_out_sender (vif.sig_out_sender),
             		.io_irq (vif.sig_irq)
		);

   	initial begin
		//Registers the Interface in the configuration block so that other
		//blocks can use it
		uvm_resource_db#(virtual sha1_if)::set
			(.scope("ifs"), .name("sha1_if"), .val(vif));

		//Executes the test
		run_test();
	end

	//Variable initialization
	initial begin
		vif.sig_clk <= 1'b1;
	end

	//Clock generation
	always
		#5 vif.sig_clk = ~vif.sig_clk;
endmodule
