`timescale 1ns/1ps
`include "common_defs.v"

module input_port (clk, rst, route_dir, write, data_in, read, data_out, empty, full, x_dst, y_dst, req);

parameter LINKWIDTH = 188;
parameter OUT_PORT_CNT = 5; // number of output ports of the router
parameter FIFO_ADDR_WIDTH = 1; // log(FIFO_SIZE)
parameter FIFO_SIZE = 2;

input clk, rst, write, read;
input [OUT_PORT_CNT-1:0] route_dir;
input [LINKWIDTH-1:0] data_in;
output empty, full;
output [LINKWIDTH-1:0] data_out;
output [3:0] x_dst, y_dst;
output reg [OUT_PORT_CNT-1:0] req;

// input fifo
fifo #(
    .WIDTH(LINKWIDTH),
    .ADDR_WIDTH(FIFO_ADDR_WIDTH),
    .SIZE(FIFO_SIZE))
  input_fifo(
    .clk(clk),
    .rst(rst),
    .write(write),
    .data_in(data_in),
    .read(read),
    .data_out(data_out),
    .empty(empty),
    .full(full));

assign x_dst = data_out[`DEST_X_END:`DEST_X_BEGIN];
assign y_dst = data_out[`DEST_Y_END:`DEST_Y_BEGIN];

always @* begin
   if(empty) 
     req <= 0;
   else
     req <= route_dir;
end

endmodule
