`timescale 1ns/1ps
`include "common_defs.v"

// implements XY-routing, assuming 4-bits for X- and Y- tile addresses
module route_comp_1port (x_dst, y_dst, x_cur, y_cur, dir);

   input [3:0] x_dst, y_dst, x_cur, y_cur;
   output [`DIR_CNT-1:0] dir;

   wire                  x_cur_eq_dst;
   wire                  x_cur_lt_dst;
   wire                  x_cur_gt_dst;

   wire                  y_cur_eq_dst;
   wire                  y_cur_lt_dst;
   wire                  y_cur_gt_dst;

   assign x_cur_eq_dst = (x_cur == x_dst);
   assign x_cur_lt_dst = (x_cur < x_dst);
   assign x_cur_gt_dst = ~x_cur_eq_dst & ~x_cur_lt_dst;

   assign y_cur_eq_dst = (y_dst == y_cur);
   assign y_cur_lt_dst = (y_cur < y_dst);
   assign y_cur_gt_dst = ~y_cur_eq_dst && ~y_cur_lt_dst;

   assign dir[`EAST_DIR] = x_cur_lt_dst;
   assign dir[`NORTH_DIR] = x_cur_eq_dst & y_cur_gt_dst;
   assign dir[`WEST_DIR] = x_cur_gt_dst;
   assign dir[`SOUTH_DIR] = x_cur_eq_dst & y_cur_lt_dst;
   assign dir[`LOCAL_DIR] = x_cur_eq_dst & y_cur_eq_dst;

endmodule
