import uvm_pkg::*;
`include "uvm_macros.svh"
//import router_pkg::*;

class router_s_agent_config extends uvm_object;

   localparam string s_my_config_id = "router_s_agent_config";
   localparam string s_no_config_id = "no config";
   localparam string s_my_config_type_error_id = "config type error";	

   `uvm_object_utils( router_s_agent_config )

    virtual router_if vif;	
 
   //uvm_active_passive_enum active = UVM_ACTIVE;
   uvm_active_passive_enum active = UVM_PASSIVE;
 
   extern static function router_s_agent_config get_config( uvm_component c);	

   extern function new( string name = "router_s_agent_config" ); 	  
   
endclass: router_s_agent_config

   function router_s_agent_config::new( string name = "router_s_agent_config" );
      super.new( name );
   endfunction

   function router_s_agent_config router_s_agent_config::get_config( uvm_component c );
   router_s_agent_config t;

   if (!uvm_config_db #(router_s_agent_config)::get(c, "", s_my_config_id, t) )
     `uvm_fatal("CONFIG_LOAD", $sformatf("Cannot get() configuration %s from uvm_config_db. Have you set() it?", s_my_config_id))

  return t;
  endfunction
