import uvm_pkg::*;
`include "uvm_macros.svh"
import sha1tile_pkg::*;

class sha1tile_agent_config extends uvm_object;

   localparam string s_my_config_id = "sha1tile_agent_config";
   localparam string s_no_config_id = "no config";
   localparam string s_my_config_type_error_id = "config type error";

   `uvm_object_utils( sha1tile_agent_config )
 
   virtual sha1tile_if vif;

   uvm_active_passive_enum active = UVM_ACTIVE;
   //uvm_active_passive_enum active = UVM_PASSIVE;
 
   extern static function sha1tile_agent_config get_config( uvm_component c);	

   extern function new( string name = "sha1tile_agent_config" ); 	  
   
endclass: sha1tile_agent_config

   function sha1tile_agent_config::new( string name = "sha1tile_agent_config" );
      super.new( name );
   endfunction 

   function sha1tile_agent_config sha1tile_agent_config::get_config( uvm_component c );
   sha1tile_agent_config t;

   if (!uvm_config_db #(sha1tile_agent_config)::get(c, "", s_my_config_id, t) )
     `uvm_fatal("CONFIG_LOAD", $sformatf("Cannot get() configuration %s from uvm_config_db. Have you set() it?", s_my_config_id))

  return t;
endfunction
