import uvm_pkg::*;
`include "uvm_macros.svh"
import sha1tiletest_pkg::*;
//`include "sha1_agent_config.sv"
//`include "sha1_agent.sv"
//`include "router_s_agent_config.sv"
//`include "router_s_agent.sv"

class sha1tile_test extends uvm_test;
		`uvm_component_utils(sha1tile_test);

		sha1tile_env		sha1tile_envi;
   		sha1tile_env_config   	sha1tile_env_cfg;
		sha1_agent_config 	sha1_agent_cfg;
   		router_s_agent_config 	router_s_agent_cfg;
   		sha1tile_agent_config 	sha1tile_agent_cfg;	

		function new(string name, uvm_component parent);
			super.new(name, parent);
		endfunction: new

		function void build_phase(uvm_phase phase);
			super.build_phase(phase);
	
			sha1tile_env_cfg  = sha1tile_env_config ::type_id::create( "sha1tile_env_cfg" );

      			sha1_agent_cfg  = sha1_agent_config::type_id::create( "sha1_agent_cfg" );
			if ( !uvm_config_db #( virtual sha1_if )::get
		        	( .cntxt( this ), .inst_name( "" ), .field_name( "SHA1_vif" ), .value( sha1_agent_cfg.vif ) ) ) begin
            			`uvm_error( "sha1tile_test", "sha1_if not found" )
      			end
			sha1tile_env_cfg.sha1_agent_cfg = sha1_agent_cfg;

      			router_s_agent_cfg = router_s_agent_config::type_id::create( "router_s_agent_cfg" );
			if ( !uvm_config_db #( virtual router_if )::get
		        	( .cntxt( this ), .inst_name( "" ), .field_name( "ROUTER_vif" ), .value( router_s_agent_cfg.vif ) ) ) begin
            			`uvm_error( "sha1tile_test", "router_if not found" )
      			end
			sha1tile_env_cfg.router_s_agent_cfg = router_s_agent_cfg;

			sha1tile_agent_cfg  = sha1tile_agent_config::type_id::create( "sha1tile_agent_cfg" );     			
			if ( !uvm_config_db #( virtual sha1tile_if )::get
		        	( .cntxt( this ), .inst_name( "" ), .field_name( "SHA1TILE_vif" ), .value( sha1tile_agent_cfg.vif ) ) ) begin
            			`uvm_error( "sha1tile_test", "sha1tile_if not found" )
      			end
 			sha1tile_env_cfg.sha1tile_agent_cfg = sha1tile_agent_cfg;
 
	      		uvm_config_db #( sha1tile_env_config )::set
         		( .cntxt( this ), .inst_name( "*" ), .field_name( "sha1tile_env_cfg" ), .value( sha1tile_env_cfg ) );
 			sha1tile_envi = sha1tile_env::type_id::create(.name("sha1tile_envi"), .parent(this));

		endfunction: build_phase

		task run_phase(uvm_phase phase);
			sha1tile_sequence sha1tile_seq;

			phase.raise_objection(.obj(this));
				sha1tile_seq = sha1tile_sequence::type_id::create(.name("sha1tile_seq"), .contxt(get_full_name()));
				assert(sha1tile_seq.randomize());
				sha1tile_seq.start(sha1tile_envi.sha1tile_agnt.sha1tile_seqr);
			phase.drop_objection(.obj(this));
		endtask: run_phase
endclass: sha1tile_test
