`timescale 1ns/1ps
`include "common_defs.v"

module xbar_5x5 (sel, data_in, data_out);

parameter XBAR_LINKWIDTH = 8;

input [XBAR_LINKWIDTH*`DIR_CNT-1:0] data_in;
input [`DIR_CNT*`DIR_CNT-1:0] sel;
output [XBAR_LINKWIDTH*`DIR_CNT-1:0] data_out;

// data out east
assign data_out[XBAR_LINKWIDTH*(`EAST_DIR+1)-1:XBAR_LINKWIDTH*`EAST_DIR] =
  (sel[`DIR_CNT*`EAST_DIR+`NORTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`NORTH_DIR+1)-1:XBAR_LINKWIDTH*`NORTH_DIR] :
  (sel[`DIR_CNT*`EAST_DIR+`WEST_DIR]) ? data_in[XBAR_LINKWIDTH*(`WEST_DIR+1)-1:XBAR_LINKWIDTH*`WEST_DIR] :
  (sel[`DIR_CNT*`EAST_DIR+`SOUTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`SOUTH_DIR+1)-1:XBAR_LINKWIDTH*`SOUTH_DIR] :
  (sel[`DIR_CNT*`EAST_DIR+`EAST_DIR]) ? data_in[XBAR_LINKWIDTH*(`EAST_DIR+1)-1:XBAR_LINKWIDTH*`EAST_DIR] :
  (sel[`DIR_CNT*`EAST_DIR+`LOCAL_DIR]) ? data_in[XBAR_LINKWIDTH*(`LOCAL_DIR+1)-1:XBAR_LINKWIDTH*`LOCAL_DIR] : 0;

// data out north
assign data_out[XBAR_LINKWIDTH*(`NORTH_DIR+1)-1:XBAR_LINKWIDTH*`NORTH_DIR] =
  (sel[`DIR_CNT*`NORTH_DIR+`NORTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`NORTH_DIR+1)-1:XBAR_LINKWIDTH*`NORTH_DIR] :
  (sel[`DIR_CNT*`NORTH_DIR+`WEST_DIR]) ? data_in[XBAR_LINKWIDTH*(`WEST_DIR+1)-1:XBAR_LINKWIDTH*`WEST_DIR] :
  (sel[`DIR_CNT*`NORTH_DIR+`SOUTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`SOUTH_DIR+1)-1:XBAR_LINKWIDTH*`SOUTH_DIR] :
  (sel[`DIR_CNT*`NORTH_DIR+`EAST_DIR]) ? data_in[XBAR_LINKWIDTH*(`EAST_DIR+1)-1:XBAR_LINKWIDTH*`EAST_DIR] :
  (sel[`DIR_CNT*`NORTH_DIR+`LOCAL_DIR]) ? data_in[XBAR_LINKWIDTH*(`LOCAL_DIR+1)-1:XBAR_LINKWIDTH*`LOCAL_DIR] : 0;

// data out west
assign data_out[XBAR_LINKWIDTH*(`WEST_DIR+1)-1:XBAR_LINKWIDTH*`WEST_DIR] =
  (sel[`DIR_CNT*`WEST_DIR+`NORTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`NORTH_DIR+1)-1:XBAR_LINKWIDTH*`NORTH_DIR] :
  (sel[`DIR_CNT*`WEST_DIR+`WEST_DIR]) ? data_in[XBAR_LINKWIDTH*(`WEST_DIR+1)-1:XBAR_LINKWIDTH*`WEST_DIR] :
  (sel[`DIR_CNT*`WEST_DIR+`SOUTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`SOUTH_DIR+1)-1:XBAR_LINKWIDTH*`SOUTH_DIR] :
  (sel[`DIR_CNT*`WEST_DIR+`EAST_DIR]) ? data_in[XBAR_LINKWIDTH*(`EAST_DIR+1)-1:XBAR_LINKWIDTH*`EAST_DIR] :
  (sel[`DIR_CNT*`WEST_DIR+`LOCAL_DIR]) ? data_in[XBAR_LINKWIDTH*(`LOCAL_DIR+1)-1:XBAR_LINKWIDTH*`LOCAL_DIR] : 0;

// data out south
assign data_out[XBAR_LINKWIDTH*(`SOUTH_DIR+1)-1:XBAR_LINKWIDTH*`SOUTH_DIR] =
  (sel[`DIR_CNT*`SOUTH_DIR+`NORTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`NORTH_DIR+1)-1:XBAR_LINKWIDTH*`NORTH_DIR] :
  (sel[`DIR_CNT*`SOUTH_DIR+`WEST_DIR]) ? data_in[XBAR_LINKWIDTH*(`WEST_DIR+1)-1:XBAR_LINKWIDTH*`WEST_DIR] :
  (sel[`DIR_CNT*`SOUTH_DIR+`SOUTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`SOUTH_DIR+1)-1:XBAR_LINKWIDTH*`SOUTH_DIR] :
  (sel[`DIR_CNT*`SOUTH_DIR+`EAST_DIR]) ? data_in[XBAR_LINKWIDTH*(`EAST_DIR+1)-1:XBAR_LINKWIDTH*`EAST_DIR] :
  (sel[`DIR_CNT*`SOUTH_DIR+`LOCAL_DIR]) ? data_in[XBAR_LINKWIDTH*(`LOCAL_DIR+1)-1:XBAR_LINKWIDTH*`LOCAL_DIR] : 0;

// data out local
assign data_out[XBAR_LINKWIDTH*(`LOCAL_DIR+1)-1:XBAR_LINKWIDTH*`LOCAL_DIR] =
  (sel[`DIR_CNT*`LOCAL_DIR+`NORTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`NORTH_DIR+1)-1:XBAR_LINKWIDTH*`NORTH_DIR] :
  (sel[`DIR_CNT*`LOCAL_DIR+`WEST_DIR]) ? data_in[XBAR_LINKWIDTH*(`WEST_DIR+1)-1:XBAR_LINKWIDTH*`WEST_DIR] :
  (sel[`DIR_CNT*`LOCAL_DIR+`SOUTH_DIR]) ? data_in[XBAR_LINKWIDTH*(`SOUTH_DIR+1)-1:XBAR_LINKWIDTH*`SOUTH_DIR] :
  (sel[`DIR_CNT*`LOCAL_DIR+`EAST_DIR]) ? data_in[XBAR_LINKWIDTH*(`EAST_DIR+1)-1:XBAR_LINKWIDTH*`EAST_DIR] :
  (sel[`DIR_CNT*`LOCAL_DIR+`LOCAL_DIR]) ? data_in[XBAR_LINKWIDTH*(`LOCAL_DIR+1)-1:XBAR_LINKWIDTH*`LOCAL_DIR] : 0;

endmodule
