#define VERSATILE
#include "shmac.h"
#include "mutex.h"
#include "encoding.h"

#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

shmac_mutex_t mutex;
volatile uint32_t *shared = (volatile uint32_t*)UNCACHED_BASE;

#define PHASEDONE 0xad
#define CHANNELS 16

#define CPUS 3

volatile int phase;
volatile int currentChannel;
volatile bool cont[CPUS];

void shmac_flushCache(void) {
  // this also enables the cache
  *DCACHE_CTRL = 2;
}

void shmac_disableCache(void) {
  *DCACHE_CTRL = 1;
}

void shmac_flushL2Cache(void) {
  // this also enables the cache
  *L2CACHE_CTRL = 2;
}

void shmac_disableL2Cache(void) {
  *L2CACHE_CTRL = 1;
}

void panic(void) {
  while(true);
}

int main(void) {
  int id = *TILEREG_CPUID;
  int rd_data;
  int i;	

	rd_data = *((volatile int*)0x10000000); //read start address  								  //from tb
	*((volatile int*)0xfffd0000) = rd_data; //send start address 
	rd_data = *((volatile int*)0x10000004); //read size  								  		  //from tb
	*((volatile int*)0xfffd0004) = rd_data; //send size
	*((volatile int*)0xfffd0008) = 1;   //start SHA1 computation 
	
	for(i=0;i<1000;i++) {
        //dummy delay
     }

	rd_data = 0;
     	while ( rd_data == 0 ) {	
     	rd_data = *((volatile int*)0xfffd0008);  //read status reg
	rd_data = rd_data << 31;   //check done bit 	   	
	}
	
	rd_data = *((volatile int*)0xfffd000C); //read H0
	*((volatile int*)0x10000008) = rd_data;   //write H0 in RAM
	rd_data = *((volatile int*)0xfffd0010); //read H1
	*((volatile int*)0x1000000C) = rd_data;   //write H1 in RAM
	rd_data = *((volatile int*)0xfffd0014); //read H2
	*((volatile int*)0x10000010) = rd_data;   //write H2 in RAM
	rd_data = *((volatile int*)0xfffd0018); //read H3
	*((volatile int*)0x10000014) = rd_data;   //write H3 in RAM
	rd_data = *((volatile int*)0xfffd001C); //read H4
	*((volatile int*)0x10000018) = rd_data;   //write H4 in RAM

  	return 0;
}


